/*
 * Proyecto: BrwEdit
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 19/02/2007
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   COMPONENT oFolder1
   COMPONENT oFolderPage1
   COMPONENT oFolderPage2
   COMPONENT oFolderPage3
   COMPONENT oArrayBrowse1
   COMPONENT oDbfBrowse1
   COMPONENT oButton1
   COMPONENT oButton2
   COMPONENT oButton3
   COMPONENT oButton4
   COMPONENT oButton5
   COMPONENT oCdxDataSource1
   COMPONENT oDbfDataSet1
   COMPONENT oButton6
   COMPONENT oButton7
   COMPONENT oDbfBrowse1Column2
   COMPONENT oDbfBrowse1Column4
   COMPONENT oDbfBrowse1Column1
   COMPONENT oDBBrowse1
   COMPONENT oButton8
   COMPONENT oButton9
   COMPONENT oButton10
   COMPONENT oArrayBrowse1Column1
   COMPONENT oButton11
   COMPONENT oButton12
   COMPONENT oFolderPage4
   COMPONENT oSQLiteDataSource1
   COMPONENT oSQLTable1
   COMPONENT oDBBrowse1Column1
   COMPONENT oDBBrowse2
   COMPONENT oDBBrowse2Column1
   COMPONENT oDBBrowse2Column2
   COMPONENT oButton13
   COMPONENT oButton14
   COMPONENT oButton15
   COMPONENT oButton16

   METHOD CreateForm()
   METHOD ArrayBrowse1Create( oSender )
   METHOD DbfBrowse1Create( oSender )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD ArrayBrowse1Create( oSender ) CLASS TForm1

   oSender:SetArray( ::oDbfDataSet1:Struct() )

RETURN Nil

//------------------------------------------------------------------------------

METHOD DbfBrowse1Create( oSender ) CLASS TForm1

   SET DELETED ON

   USE ..\Datacontrols\Customer.dbf NEW SHARED ALIAS Cust

   oSender:SetDbf( "Cust" )

RETURN Nil

//------------------------------------------------------------------------------

CLASS TDBBrowse FROM XDBBrowse
   METHOD Insert( lFromUser )
ENDCLASS

//--------------------------------------------------------------------------

METHOD Insert( lFromUser ) CLASS TDBBrowse
//Metodo Insert de TDbfBrowse
   LOCAL xRet

   DEFAULT lFromUser TO .F.

   xRet := ::OnInsert()

   IF Valtype( xRet ) == "L" .AND. !xRet
      RETURN .F.
   ENDIF

   IF ! ::lAllowInsert .AND. lFromUser
      RETURN .F.
   ENDIF

   IF ::lEditMode .OR. ! ::IsEditable()
      RETURN .F.
   ENDIF

   ::DrawLine( Nil, .F. )

   ::nEditMode := beINSERT

   ::nPhantomRow := ::nRowSel

   ::Refresh()

*   ::Edit( lFromUser ) //No entramos en edicin
//Fin evento Insert de TDbfBrowse


If ::oDataSet:ClassName() == "TDbfDataSet"
//Metodo Append de TDBBrowse... modificando Append por Edit
//Funciona en DBBrowses DBFs, per no en SQLite ni MariaDB
	IF ::oDataset == Nil .OR. !::oDataSet:lOpen .OR. ::oDataset:lReadOnly
      RETURN .F.
   ENDIF

*   IF !::Super:Append( lFromUser )
   IF !::Super:Edit( lFromUser )
      RETURN .F.
   ELSE
      IF ::lAutoSave .AND. !::oDataSet:AddNew() // AddNew... lanza error "Already in Edit Mode [#0]"
         RETURN .F.
      ENDIF
   ENDIF
   ::Refresh()
//Fin evento Append de TDbfBrowse
*/
Else //::oDataSet:ClassName() == "TSQLTable"
   ::Edit( lFromUser )
   AEval( ::aCols, {|x| x:oGridEdit:cText := "" } )
   ::oDataSet:Blank()
   ::oDataSet:oRecords:AddNew()
   ::Refresh()
EndIf

RETURN .T.
